; $Id: browse-mode.el,v 1.5 1994/05/19 19:22:54 marc Exp $

(provide 'browse-mode)

(or (assq 'browse-mode-active minor-mode-alist)
    (setq minor-mode-alist (cons '(browse-mode-active " Browse")
				 minor-mode-alist)))

(defvar browse-mode-map nil
  "*Keymap for Browse mode.")

(or browse-mode-map
    (progn
      (setq browse-mode-map (make-keymap))
      (suppress-keymap browse-mode-map)
      (define-key browse-mode-map " " 'scroll-up)
      (define-key browse-mode-map "\177" 'scroll-down)
      (define-key browse-mode-map "n" 'next-line)
      (define-key browse-mode-map "p" 'previous-line)
      (define-key browse-mode-map "N" 'scroll-up-line)
      (define-key browse-mode-map "P" 'scroll-down-line)
      (define-key browse-mode-map "b" 'bury-buffer)
      (define-key browse-mode-map "," 'goto-buffer-start)
      (define-key browse-mode-map "." 'goto-buffer-end)
      (define-key browse-mode-map "l" 'recenter-in-window)
      (define-key browse-mode-map "s" 'isearch-forward-regexp)
      (define-key browse-mode-map "r" 'isearch-backward-regexp)
      (define-key browse-mode-map "o" 'other-window)
      (define-key browse-mode-map "x" 'toggle-browse-mode)
      (define-key browse-mode-map "q" 'remove-window)
      (define-key browse-mode-map "k" 'kill-buffer)))

(make-variable-buffer-local 'browse-mode-active)
(set-default 'browse-mode-active nil)
(make-variable-buffer-local 'browse-mode-normal-keymap)

(defun browse-mode ()
  "Minor mode for browsing through a buffer.

Here are the commands:
\\{browse-mode-map}"
  (interactive)
  (setq browse-mode-active buffer-read-only)
  (setq browse-mode-normal-keymap (current-local-map))
  (set-browse-mode))

(defun set-browse-mode ()
  (cond ((not (boundp 'browse-mode-active))
	 (browse-mode))
	(buffer-read-only
	 (setq browse-mode-active t)
	 (use-local-map browse-mode-map))
	(t
	 (setq browse-mode-active nil)
	 (use-local-map browse-mode-normal-keymap)))
  (set-buffer-modified-p (buffer-modified-p)))

(defun toggle-browse-mode ()
  "Toggle browse mode on/off"
  (interactive)
  (toggle-read-only)
  (set-browse-mode))