; functions to allow mh-replying to discuss transactions

(defun discuss-mh-reply-insert-headers (to cc subject)
  (search-backward "Subject:")
  (forward-line)
  (insert (format "In-Reply-To: [%d] in %s\n" discuss-show-num
		  discuss-current-meeting))
  (goto-char (point-max)))

(defun s (a) (if (string-equal a "") nil a))

(defun discuss-mh-reply-get-field (f)
  (require 'mh-utils)
  (save-excursion (mh-get-field f)))

(defun discuss-mh-reply ()
  "Reply to the current discuss transaction with mh-rmail"
  (interactive)
  (let (subject from to cc mh-compose-letter-hook tsubject tsender)
    (setq tsubject (discuss-mh-reply-get-field "Subject:")
	  tsender (or (s (discuss-mh-reply-get-field "Reply-To:"))
		      (discuss-mh-reply-get-field "From:")))
    (cond ((string-match "digest" tsubject)
	   (save-excursion
	     (save-restriction
	       (or
		(search-backward "\n------------------------------\n" nil t)
		(search-backward "\n----------------------------------------------------------------------*\n" nil t)
	        (goto-char (point-min)))
	       (forward-line 2)
	       (let ((beg (point)))
		 (search-forward "\n------------------------------\n")
		 (narrow-to-region beg (point))
		 (setq subject (discuss-mh-reply-get-field "Subject:")
		       from (or (s (discuss-mh-reply-get-field "Reply-To:"))
				(discuss-mh-reply-get-field "From:"))
		       to (discuss-mh-reply-get-field "To:")
		       cc (list tsender
				(discuss-mh-reply-get-field "Cc:")))))))
	  (t
	   (setq subject tsubject
		 from (or (s (discuss-mh-reply-get-field "Reply-To:"))
			  (discuss-mh-reply-get-field "From:"))
		 to (discuss-mh-reply-get-field "To:")
		 cc (list (discuss-mh-reply-get-field "Cc:")))))
    
    (if (and (> (length subject) 3)
	     (not (string-match "[Rr]e: " (substring subject 0 4))))
	(setq subject (concat "Re: " subject)))
    
    (let ((mto from)
	  (mcc 
	   (let ((cclist (cons to cc))
		 (ccstr ""))
	     (while cclist
	       (if (not (string-equal (car cclist) ""))
		   (setq ccstr
			 (if (string-equal ccstr "")
			     (car cclist)
			   (concat (car cclist) ", " ccstr))))
	       (setq cclist (cdr cclist)))
	     ccstr))
	  (msubject subject))
      
;;; This is all which needs to be conditionalized to use something besides mh
      
      (setq mh-compose-letter-hook 'discuss-mh-reply-insert-headers)
      
      (require 'mh-comp)

      (mh-find-path)
      (mh-send-sub mto mcc msubject
		   (current-window-configuration)))))
