(defvar display-prefix ">> ")

(defun display-region (str)
  "indent the region with the contents of display-prefix, or prompts if
optional argument is given"
  (interactive (list (if current-prefix-arg
			 (read-string "Prefix: ")
		         display-prefix)))
  (save-excursion
    (beginning-of-line)
    (exchange-point-and-mark)
    (beginning-of-line)
    (if (< (point) (mark))
	(narrow-to-region (point) (mark))
        (narrow-to-region (mark) (point)))
    (goto-char (point-min))
    (beginning-of-line)
    (while (not (eobp))
      (insert str)
      (forward-line 1))
    (widen)))
