(require 'pgp-lib)
(require 'mh-e)

(defun pgp-mh-goto-header-separator ()
  (goto-char (point-min))
  (if (not (re-search-forward "-------\n" nil t))
      (re-search-forward "\n[ \t]*\n" nil 'foo)))

(defun pgp-mail-recipient ()
  (save-excursion
    (save-restriction
      (goto-char (point-min))
      (pgp-mh-goto-header-separator)
      (narrow-to-region (point-min) (point))
      (goto-char (point-min))
      (if (re-search-forward "^To:\\([ \t\n]\\)\\([^, \t\n]+\\)" nil t)
	  (buffer-substring (match-beginning 2) (match-end 2))))))

(defun pgp-narrow-to-mail-body ()
  (pgp-mh-goto-header-separator)
  (narrow-to-region (point) (point-max)))

(defun pgp-encrypt-mail-buffer ()
  (interactive)
  (let ((to (pgp-mail-recipient)) min max)
    (save-excursion
      (save-restriction
	(pgp-narrow-to-mail-body)
	(setq min (point-min)
	      max (point-max))))
    (if to (pgp-frob-region-in-place min max (list "-awe") (list to)))))

(defun pgp-mh-frob-buffer ()
  (interactive)
  "If the buffer is an mh folder buffer, decrypt the message
under the cursor.  If it's a draft buffer, encrypt it."

  (cond ((and (eq 'major-mode 'mh-folder-mode)
	      (not mh-summarize))
	 (set-buffer mh-show-buffer))))
