(defun save-file-instead-of-link ()
  "If the current buffer is a symlink, it is deleted and replaced with the\ncontents of the current buffer."
  (interactive)
  (if (file-symlink-p (buffer-file-name))
      (progn
	(delete-file (buffer-file-name))
	(write-file (buffer-file-name))
	(set-file-modes (buffer-file-name) (+ (* 6 8 8) (* 4 8) 4)))
      (princ (format "%s is not a symlink." (buffer-file-name)))))
